from collections import deque

n, m, k = map(int, input().split())
graph = [[] for i in range (n + 1)]

for i in range (m):
    b, a = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

quards = []
for i in range (k):
    p, h = map(int, input().split())
    quards.append((p,h))

protected = set()

def bfs(start, max_distance):
    queue = deque([(start, 0)])
    visited = set()

    while queue:
        current, distance = queue.popleft()

        if distance > max_distance:
            continue

        if current not in visited:
            visited.add(current)
            protected.add(current)

            for neighbor in graph[current]:
                if neighbor not in visited:
                    queue.append((neighbor, distance +1))

for p, h in quards:
    bfs(p, h)

print(len(protected))
print (''.join(map(str, sorted(protected))))
        
                    
